SystemOrganization addCategory: #'Phantom-PrecedenceGraph'!

Object subclass: #AspectGraph
	instanceVariableNames: 'nodeSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-PrecedenceGraph'!

!AspectGraph methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 16:54'!
add: anAspectNode
	self nodeSet add: anAspectNode  ! !

!AspectGraph methodsFor: 'accessing' stamp: 'DanielGaldames 3/23/2011 12:49'!
addAll: anArray 
	anArray do: [:node | self add: node]! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/23/2011 11:28'!
existsCycle
	self nodeSet do: [:node |
		| visitor |
		visitor := AspectNodeVisitor new.
		visitor detectCycleFrom: node.
		(visitor cycledDetected) ifTrue: [
			^true]].
	^false.! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 17:17'!
getBaseNodes
	| base |
	base := OrderedCollection new.
	self setParents.
	self nodeSet do: [:node |
		node subnodes isEmpty ifTrue: [base add: node]].
	^base ! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/23/2011 17:37'!
getRootNode
	self setParents.
	self nodeSet do: [:node |
		node parents isEmpty ifTrue: [^node]].! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 16:43'!
getRoots
	| rootList |
	rootList := OrderedCollection new.
	self setParents.
	self nodeSet do: [:node |
		node parents isEmpty ifTrue: [rootList add: node]].
	^rootList ! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 17:17'!
getTopologicalSort
	| visit |
	self setParents.
	visit := AspectNodeVisitor new.
	^ visit getTopologicalOrderFrom: self getBaseNodes.! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/26/2011 19:46'!
merge: anAspectGraph 
	anAspectGraph nodeSet do: [:node | self add: node].
	anAspectGraph nodeSet do: [:node |
		node subnodes do: [:sub |
			(self nodeSet like: node) subnodes add: (self nodeSet like: sub)]].
	^self.! !

!AspectGraph methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 16:54'!
nodeSet
	^ nodeSet ifNil: [nodeSet := Set new]  ! !

!AspectGraph methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 16:53'!
nodeSet: anObject
	nodeSet := anObject! !

!AspectGraph methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 16:54'!
remove: anAspectNode
	self nodeSet remove: anAspectNode  ! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/23/2011 17:34'!
setParents
	self nodeSet do: [:node 	| node clearParents].
	self nodeSet do: [:node |
		node subnodes do: [:sub |
			sub parents add: node]].! !

!AspectGraph methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/24/2011 14:24'!
setPrecedence
	self setParents.
	self nodeSet do: [:node 	| node precedence: 0.].
	self nodeSet do: [:node 	| node IncreasePrecedence.]! !

Object subclass: #AspectNode
	instanceVariableNames: 'aspect subnodes name precedence parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-PrecedenceGraph'!

!AspectNode methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/24/2011 12:37'!
= anAspectNode
	(anAspectNode isKindOf: AspectNode) ifFalse: [^false].
	^(self aspect = anAspectNode aspect)  ! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/24/2011 14:23'!
IncreasePrecedence
	precedence := precedence  + 1.
	self subnodes do: [:node | node IncreasePrecedence]! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 19:03'!
addNode: anAspectNode 
	self subnodes add: anAspectNode! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 19:01'!
addNodes: anArray 
	anArray do: [:node | self addNode: node]! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/24/2011 12:32'!
aspect
	^ aspect. ! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/24/2011 12:49'!
aspect: AspectClass
	aspect := AspectClass! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/23/2011 17:35'!
clearParents
	self parents removeAll.! !

!AspectNode methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/24/2011 13:03'!
hash
	^ self aspect hash.! !

!AspectNode methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/24/2011 14:22'!
initialize
	super initialize.
	precedence := 0.! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 19:52'!
name: aString
	name := aString! !

!AspectNode methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/23/2011 10:52'!
nodeName
	^name! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/23/2011 17:35'!
parents
	^ parents ifNil: [parents := Set new.]  ! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/24/2011 14:22'!
precedence
	^ precedence! !

!AspectNode methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/24/2011 14:20'!
precedence: aNumber
	precedence := aNumber.! !

!AspectNode methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 19:04'!
subnodes
	^subnodes ifNil: [subnodes := Set new]  ! !

Object subclass: #AspectNodeVisitor
	instanceVariableNames: 'visitedNodes cycle lastVisited orderedNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-PrecedenceGraph'!

!AspectNodeVisitor methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 19:41'!
cycledDetected
	^cycle! !

!AspectNodeVisitor methodsFor: 'visiting' stamp: 'DanielGaldames 3/23/2011 11:28'!
detectCycleFrom: anAspectNode 
	(self visitedNodes includes: anAspectNode)
		ifTrue: [cycle := true]
		ifFalse: [
			self visitedNodes add: anAspectNode.
			anAspectNode subnodes do: [:node | self detectCycleFrom: node].
			self visitedNodes remove: anAspectNode].! !

!AspectNodeVisitor methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 17:16'!
getTopologicalOrderFrom: rootNodes
	rootNodes do: [:node | self visitInOrder: node].
	self orderedNodes withIndexDo: [:node :index | node precedence: index].
	^ self orderedNodes! !

!AspectNodeVisitor methodsFor: 'initialize-release' stamp: 'DanielGaldames 3/22/2011 19:19'!
initialize
	cycle := false! !

!AspectNodeVisitor methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 16:51'!
orderedNodes
	^ orderedNodes ifNil: [orderedNodes := OrderedCollection new]! !

!AspectNodeVisitor methodsFor: 'as yet unclassified' stamp: 'dgg 6/26/2011 16:53'!
visitInOrder: aNode
	(self visitedNodes includes: aNode) 
	ifFalse: [
		self visitedNodes add: aNode.
		aNode parents do: [:parentNode | self visitInOrder: parentNode].
		self orderedNodes add: aNode.
		]! !

!AspectNodeVisitor methodsFor: 'accessing' stamp: 'DanielGaldames 3/22/2011 19:47'!
visitedNodes
	^visitedNodes ifNil: [visitedNodes := Set new.]  ! !
